include "basics/pts.ma".
axiom eq : \forall A : Type[0] . A -> A -> Prop.
axiom refl : \forall A. \forall (x:A). (eq) (A) x x.
axiom eq_ind : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) x y) -> P y.
definition rewrite_l : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) x y) -> P y := \lambda A : Type[0]. \lambda x : A. \lambda P : A -> Prop. \lambda Hx : P x. (\lambda y : A. \lambda Heq : (eq) (A) x y. (((((((eq_ind) (A)) (x)) (\lambda j__ : A. P j__)) (Hx)) (y)) (Heq))).
definition sym_eq : \forall A. \forall (x:A). \forall (y:A). ((eq) (A) x y) -> (eq) (A) y x := \lambda A : Type[0]. \lambda x : A. \lambda y : A. \lambda Heq : (eq) (A) x y. (((((((rewrite_l) (A)) (x)) (\lambda j__ : A. (eq) (A) j__ x)) (((refl) (A)) (x))) (y)) (((((((rewrite_l) (A)) (x)) (\lambda j__ : A. (eq) (A) x j__)) (((refl) (A)) (x))) (y)) (Heq))).
definition rewrite_r : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) y x) -> P y := \lambda A : Type[0]. \lambda x : A. \lambda P : A -> Prop. \lambda Hx : P x. (\lambda y : A. \lambda Heq : (eq) (A) y x. (((((((eq_ind) (A)) (x)) (\lambda j__ : A. P j__)) (Hx)) (y)) (((((sym_eq) (A)) (y)) (x)) (Heq)))).
definition eq_coerc : \forall (A:Prop). \forall (B:Prop). (A) -> ((eq) (Prop) A B) -> B := \lambda A : Prop. \lambda B : Prop. \lambda Ha : A. (\lambda Heq : (eq) (Prop) A B. (((((((eq_ind) (Prop)) (A)) (\lambda x_19 : Prop. x_19)) (Ha)) (B)) (Heq))).
